#!/bin/sh

PATH=/sbin:/usr/sbin:/bin:/usr/bin
export PATH

LOGIN=`whoami`

home=~
datadir=$home/www/bases_mysql
pid_file=$home/www/bases_mysql/mysql.pid
php_pid_file=$home/www/php_conf/php-fpm.pid
log=$home/www/bases_mysql/mysql_log
www=$home/www/public_html
phpmyadmin=/usr/local/phpMyAdmin

mode=$1

# lien vers phpMyAdmin
cd $www

if [ ! -L "phpMyAdmin" ]
    then ln -s $phpmyadmin .
fi

# logout
cd $home

if ! test -f ".logout"
    then 
        `touch .logout`
fi

deja=`grep -c 'serveur_web.sh' .logout`

if [ $deja -eq 0 ]
    then 
        echo '~/www/serveur_web.sh stop' >> ~/.logout
fi

# my.cnf
if [ -f ~/.my.cnf ]
    then
        rm -f ~/.my.cnf
fi

# conf httpd
username=`whoami`
group=`id -g -n`
homedir=`echo ~`

sed -i "s?{username}?$username?g" ~/www/httpd_conf/httpd.conf 
sed -i "s?{group}?$group?g" ~/www/httpd_conf/httpd.conf 
sed -i "s?{homedir}?$homedir?g" ~/www/httpd_conf/httpd.conf 

# conf php-fpm
sed -i "s?{username}?$username?g" ~/www/php_conf/php-fpm.conf
sed -i "s?{homedir}?$homedir?g" ~/www/php_conf/php-fpm.conf

# conf mysql
cp -f $datadir/my.cnf ~/.my.cnf

case "$mode" in
  'start')

	# Apache
        httpd -f ~/www/httpd_conf/httpd.conf -k start

	# PHP
	php-fpm --fpm-config ~/www/php_conf/php-fpm.conf

	# MariaDB
	mysqld_safe --local-infile=1 --datadir=$datadir --pid-file=$pid_file --user=$LOGIN  --socket=/tmp/mysql.sock  --innodb=1  --log-error=$log &
    ;;

  'stop')

	# Apache
        httpd -f ~/www/httpd_conf/httpd.conf -k stop

	# PHP
	if test -f "$php_pid_file"
	then
		php_pid=`cat $php_pid_file`
		echo "Killing php-fpm with pid $php_pid"
		kill $php_pid
	fi

	if test -f "$pid_file"
        then
      
      		mysqld_pid=`cat $pid_file`
      		echo "Killing mysqld with pid $mysqld_pid"
      		kill $mysqld_pid

      		sleep 1
      		while [ -s $pid_file -a "$flags" != aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa ]
      		do
        		[ -z "$flags" ] && echo "Wait for mysqld to exit\c" || echo ".\c"
        		flags=a$flags
        		sleep 1
      		done

      		if [ -s $pid_file ]
         	then echo " gave up waiting!"
      		elif [ -n "$flags" ]
         	then echo " done"
      fi
fi
    ;;

  *)
    echo "usage: $0 start|stop"
    exit 1
    ;;
esac
